﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(){
            var data = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.dataSource = data;
            return View();
        }
        public static List<dataSrc> order = new List<dataSrc>()
        {
            new dataSrc(1024,1,true,false),
            new dataSrc(1025,2,false,true),
            new dataSrc(1026,3,false,false),
            new dataSrc(1027,4,true,false),
            new dataSrc(1028,5,false,true),
            new dataSrc(1029,6,true,false),
            new dataSrc(1030,7,false,true),
            new dataSrc(1031,8,true,false),
            new dataSrc(1032,9,false,true),
            new dataSrc(1024,10,true,false),
            new dataSrc(1024,11,true,false),
        };
        public ActionResult UpdateBatch(List<dataSrc> changed, List<dataSrc> added, List<dataSrc> deleted)
        { 
            var data = order;
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = order;
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.count = Data.AsQueryable().Count();
            if (dm.Skip != null)
                Data = operation.PerformSkip(Data, dm.Skip);
            if(dm.Take != null)
                Data = operation.PerformTake(Data, dm.Take);
            result.result = Data;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = new NorthwindDataContext().EmployeeViews.ToList();
            DataOperations operation = new DataOperations();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, true, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = new NorthwindDataContext().EmployeeViews.ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class dropDown
        {
            public string Tag { get; set; }
            public int EmployeeID { get; set; }
            public dropDown() { }
            public dropDown(int val, string txt)
            {
                this.Tag = txt;
                this.EmployeeID = val;
            }
        }
        public class dataSrc
        {
            public dataSrc() { }

            public dataSrc(int ordID, int empID, bool V1, bool V2)
            {
                this.OrderID = ordID;
                this.EmployeeID = empID;
                this.Verified1 = V1;
                this.Verified2 = V2;
            }

            public int OrderID { get; set; }
            public int EmployeeID { get; set; }
            public bool Verified1 { get; set; }
            public bool Verified2 { get; set; }

        }
    }
}